<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>Cacti – Spikekill</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <link rel="stylesheet" href="Cacti-Github.css" />
</head>
<body>
<h1 id="spikekill">Spikekill</h1>
<h2 id="warning">Warning</h2>
<p>Spikekill is designed to overwrite specific data points in one or more RRD files. You should use great caution when running Spikekill, and you should always ensure you have proper backups from which to restore your RRDfiles if Spikekill performs a modification that you did not expect.</p>
<h2 id="overview">Overview</h2>
<p>Spikekill is a tool used to remove spikes in a graph. Spikes can appear in a graph after a device reboots, or when you switch from 32-bit to 64-bit interface counters on a device. Spikekill works by statistically analyzing the data contained inside an RRDfile, and overwriting specific data points. It offers 4 methods by which to analyze the data and selectively overwrite data points:</p>
<ol>
<li><p><em>Standard Deviation</em></p>
<p>Calulates the <a href="https://en.wikipedia.org/wiki/Standard_deviation">standard deviation</a> of the data, and overwrites data points that are <em>N</em> times higher than the standard deviation.</p></li>
<li><p><em>Variance Average</em></p>
<p>Calculates the average value of the data, and overwrites data points that are <em>N</em> percent higher than the average.</p></li>
<li><p><em>GapFill</em></p>
<p>Finds gaps in the data (missing data points) and also finds data points that are <em>N</em> percent higher than the average, and overwrites them, but only does so inside the specified time range.</p></li>
<li><p><em>Float</em></p>
<p>Overwrites all data points that are within a specified time range.</p></li>
</ol>
<h2 id="how-to-use">How to use</h2>
<h3 id="gui">GUI</h3>
<p>Spikekill is easily run on a graph with a couple mouse clicks in the Cacti GUI:</p>
<ol>
<li><p>On Cacti's main <code>Graph</code> tab, click the Spikekill icon <img src="images/spikekill.gif" alt="Spikekill-icon" /> next to a graph.</p></li>
<li><p>In the drop-down menu that appears, review your current settings by hovering on <code>Settings</code> and reviewing each item, making changes if desired.</p></li>
<li><p>Run Spikekill by choosing one of the four methods available in the drop-down menu. Spikekill runs immediately, and the graph may be modified, depending on your settings. The graph is refreshed when Spikekill is finished.</p></li>
</ol>
<h3 id="cli">CLI</h3>
<p>Spikekill also has a flexible command line interface. The following example will help you get started.</p>
<pre class="console"><code>shell&gt;php cli/removespikes.php --help
</code></pre>
<h2 id="settings">Settings</h2>
<p>Spikekill requires certain values to successfully calculate which data points to overwrite. The following settings are customizable:</p>
<ol>
<li><p><em>Replacement Method</em></p>
<p>When Spikekill identifies data points to overwrite, the value of <em>Replacement Method</em> represents the data that will be written in place of each data point.</p>
<p>When <em>Replacement Method</em> is set to <code>NaN</code>, running Spikekill using <code>GapFill</code> or <code>Float</code> methods will perform no modifications. Please be aware of <a href="https://github.com/Cacti/cacti/issues/3673">Issue #3673</a>, where 'Last Known Good' is always used, regardless of setting.</p></li>
<li><p><em>Standard Deviations</em></p>
<p>When using the Standard Deviation method, the value of <em>Standard Deviations</em> is the coefficient which determines how many times above the standard deviation the data must be to be considered a spike.</p></li>
<li><p><em>Variance Percentage</em></p>
<p>When using the Variance Average method, the value of <em>Variance Percentage</em> is the coefficient which determines how much higher than the average the data must be to be considered a spike.</p></li>
<li><p><em>Variance Outliers</em></p>
<p>When using the Variance Average method, the highest <em>N</em> values and the lowest <em>N</em> values are considered <em>outliers</em>. These outliers are ignored when calculating the average of the data.</p></li>
<li><p><em>Kills Per RRA</em></p>
<p>Spikekill will limit the number of data points that it overwrites to the value of <em>Kills Per RRA</em>. For reference, a single RRDfile can contain multiple <em>data sources</em> and multiple <em>archives</em>. Therefore, the total number of data points that could be overwritten in a single RRDfile will be determined by the formula:</p>
<pre class="console"><code>(number_of_RRAs) x (number_of_data_sources) x (Kills_Per_RRA)
</code></pre>
<p>This only applies when using the <code>Standard Deviation</code> or <code>Variance Average</code> methods, and does not apply when using the <code>GapFill</code> or <code>Float</code> methods.</p></li>
</ol>
<p>The above settings are maintatined individually for each Cacti user. The default values can be changed globally in the Cacti settings, found at Configuration &gt; Settings &gt; Spikes. A user can change her or his individual settings by selecting different choices in the Spikekill menu which appears next to a graph.</p>
<h2 id="detailed-operation">Detailed Operation</h2>
<h3 id="independence-between-each-rrads-pair">Independence between each RRA:DS pair</h3>
<p>When Spikekill runs, it analyzes each data source (DS) of each round-robin archive (RRA) independently. During analysis, it calculates values for <code>average</code> and <code>standard deviation</code> for each RRA:DS pair.</p>
<p>To understand this better, consider the following example.</p>
<ul>
<li><p>You have a round-robin database (RRD) file that stores traffic levels on a router interface.</p></li>
<li><p>You have two DSes, which are <code>traffic_in</code> and <code>traffic_out</code>.</p></li>
<li><p>You also have selected three profiles, which are 1 minute for 7 days, 15 minutes for 5 weeks, and 1 hour for 3 years.</p></li>
<li><p>Lastly, you have three consolidation functions (CF), which are <code>average</code>, <code>min</code>, and <code>max</code>.</p></li>
</ul>
<p>In this example, you have 9 RRAs (3 profiles multiplied by 3 CFs). Therefore, Spikekill will calculate 18 averages and 18 standard deviation values (9 RRAs multiplied by 2 DSes). Data points for each RRA:DS pair will be compared against their respective <code>average</code> and <code>standard deviation</code> values.</p>
<h3 id="search-order">Search order</h3>
<p>Spikekill searches for spikes in the same order as <code>rrddump</code> exports data, which is sequentially by RRA, from oldest to newest data points within each RRA. Data points are overwritten if they exceed the maximum allowed threshold or if they do not reach the minimum required threshold.</p>
<p>Spikekill will cease overwriting data points for any individual RRA when it has reached the value of <em>Kills Per RRA</em>, counting all DSes of that RRA together. It will then begin the process again on the next RRA.</p>
<p>This means that for any given RRA, older spikes will always be overwritten before newer spikes. However, newer spikes in one RRA can still be overwritten before older spikes in a different RRA, since the thresholds are different per RRA:DS pair.</p>
<hr />
<p><copy>Copyright (c) 2004-2021 The Cacti Group</copy></p>
</body>
</html>
